function love.load()
	love.graphics.setCaption("Snake 2.0")
	love.graphics.setMode(650, 650, false, true, 5)
	image = love.graphics.newImage("Snizake.tga")
	love.graphics.setIcon(image)
	love.graphics.setBackgroundColor(230,230,230)
   
	fontusdallas = love.graphics.newFont("ussdallas.ttf", 15)
	love.graphics.setFont(fontusdallas)
	
   --Set Random Seed
   math.randomseed(os.time());
   --world = love.physics.newWorld( 0, 0, love.graphics.getWidth(), love.graphics.getHeight() )
   world = love.physics.newWorld(0, 0, 690, 690)
   world:setGravity(0, 0)
   world:setMeter(64)
   world:setCallbacks(add, persist, rem, result)
   
   objects = {}
   objects.bordi = {}
   objects.bordi.superiore = {}
   objects.bordi.superiore.body = love.physics.newBody(world, 690/2, 10, 0, 0)
   objects.bordi.superiore.shape = love.physics.newRectangleShape(objects.bordi.superiore.body, 0, 0, 650, 20, 0)
   objects.bordi.superiore.shape:setData("wall")
   objects.bordi.inferiore = {}
   objects.bordi.inferiore.body = love.physics.newBody(world, 690/2, 680, 0, 0)
   objects.bordi.inferiore.shape = love.physics.newRectangleShape(objects.bordi.inferiore.body, 0, 0, 650, 20, 0)
   objects.bordi.inferiore.shape:setData("wall")
   objects.bordi.sinistro = {}
   objects.bordi.sinistro.body = love.physics.newBody(world, 10, 690/2, 0, 0)
   objects.bordi.sinistro.shape = love.physics.newRectangleShape(objects.bordi.sinistro.body, 0, 0, 20, 650, 0)
   objects.bordi.sinistro.shape:setData("wall")
   objects.bordi.destro = {}
   objects.bordi.destro.body = love.physics.newBody(world, 680, 690/2, 0, 0)
   objects.bordi.destro.shape = love.physics.newRectangleShape(objects.bordi.destro.body, 0, 0, 20, 650, 0)
   objects.bordi.destro.shape:setData("wall")
   
   objects.ball = {}
   objects.ball.body = love.physics.newBody(world, 690/2, 690/2, 15, 0)
   objects.ball.shape = love.physics.newCircleShape(objects.ball.body, 0, 0, 15)
   objects.ball.shape:setData("palla")
   
   objects.slaves = {}
   
   objects.slaves[1] = {}
   objects.slaves[1].body = love.physics.newBody(world, objects.ball.body:getX() - 20, objects.ball.body:getY(), 10, 0)
   objects.slaves[1].body:setLinearDamping(2)
   objects.slaves[1].shape = love.physics.newCircleShape(objects.slaves[1].body, 0, 0, 13)
   objects.slaves[1].shape:setData("body")
   
   objects.slaves[2] = {}
   objects.slaves[2].body = love.physics.newBody(world, objects.slaves[1].body:getX() - 20, objects.slaves[1].body:getY(), 10, 0)
   objects.slaves[2].body:setLinearDamping(2)
   objects.slaves[2].shape = love.physics.newCircleShape(objects.slaves[2].body, 0, 0, 13)
   objects.slaves[2].shape:setData("body")
   
   nslaves = 2
   
   objects.joints = {}
   
   objects.joints[1] = {}
   objects.joints[1].joint = love.physics.newDistanceJoint( objects.ball.body, objects.slaves[1].body, objects.ball.body:getX(), objects.ball.body:getY(), objects.slaves[1].body:getX(), objects.slaves[1].body:getY())
   objects.joints[1].joint:setCollideConnected(false)
   objects.joints[1].joint:setDamping(.01)
   
   objects.joints[2] = {}
   objects.joints[2].joint = love.physics.newDistanceJoint( objects.slaves[1].body, objects.slaves[2].body, objects.slaves[1].body:getX(), objects.slaves[1].body:getY(), objects.slaves[2].body:getX(), objects.slaves[2].body:getY())
   objects.joints[2].joint:setCollideConnected(false)
   objects.joints[2].joint:setDamping(.01)
   
   njoints = 2
   
   objects.mela = {}
   objects.mela.body = love.physics.newBody(world, math.random(638) + 6 + 20, math.random(638) + 6 + 20, 0, 0)
   objects.mela.shape = love.physics.newCircleShape(objects.mela.body, 0, 0, 7)
   objects.mela.shape:setSensor(true)
   objects.mela.shape:setData("mela")
   
   gameover = false
end

function love.draw()
   --disegna la mela
   love.graphics.setColor(61,61,61)
   love.graphics.circle("fill", objects.mela.body:getX() - 20,objects.mela.body:getY() - 20,7,64)
   love.graphics.setColor(200,0,0)
   love.graphics.circle("fill", objects.mela.body:getX() - 20,objects.mela.body:getY() - 20,5,64)
   
   --disegna il corpo
   for i = nslaves, 1, -1 do
		love.graphics.setColor(61,61,61)
		love.graphics.circle("fill", objects.slaves[i].body:getX() - 20,objects.slaves[i].body:getY() - 20,13,64)
		love.graphics.setColor(168,205,66)
		love.graphics.circle("fill", objects.slaves[i].body:getX() - 20,objects.slaves[i].body:getY() - 20,10,64)
    end

   
   --disegna la palla
   love.graphics.setColor(61,61,61)
   love.graphics.circle("fill", objects.ball.body:getX() - 20,objects.ball.body:getY() - 20,15,64)
   love.graphics.setColor(168,205,66)
   love.graphics.circle("fill", objects.ball.body:getX() - 20,objects.ball.body:getY() - 20,12,64)
   
   --disegna i punteggi
   love.graphics.setColor(41,41,41)
   love.graphics.print("SCORE: " .. (nslaves - 2) * 100, 10, 10)
   
   --game over
   if gameover then
		love.graphics.setColor(41,41,41)
		love.graphics.printf("GAME OVER\npremere r per ricominciare", 650/4, 650/2 - 30,650/2,"center")
   end
end

function love.update(dt)
	if gameover == false then
		world:update(dt)
		if love.keyboard.isDown("up") then
		  objects.ball.body:applyForce(0, -100 - (nslaves * 10))
		end
		if love.keyboard.isDown("down") then
		  objects.ball.body:applyForce(0, 100 + (nslaves * 10))
		end
		if love.keyboard.isDown("left") then
		  objects.ball.body:applyForce(-100 - (nslaves * 10), 0)
		end
		if love.keyboard.isDown("right") then
		  objects.ball.body:applyForce(100 + (nslaves * 10), 0)
		end
	end
	if love.keyboard.isDown("escape") then
	  love.event.push("q")
	end
end

function love.keyreleased( key )
	if ((key == "r") or (key == "a")) then
		--reset game
		if nslaves > 2 then
			for i = 3, nslaves, 1 do
				objects.joints[i].joint:destroy()
				objects.joints[i] = nil
				objects.slaves[i].body:setPosition(1024, 1024)
				objects.slaves[i].body:setMass(0,0,0,0)
				objects.slaves[i].body:putToSleep( )
				objects.slaves[i].body = nil
				objects.slaves[i].shape = nil
				objects.slaves[i] = nil
			end
			njoints = 2
			nslaves = 2
		end
		objects.ball.body:setPosition(690/2, 690/2)
		objects.slaves[1].body:setPosition(objects.ball.body:getX() - 20, objects.ball.body:getY())
		objects.slaves[2].body:setPosition(objects.slaves[1].body:getX() - 20, objects.slaves[1].body:getY())
		objects.ball.body:setLinearVelocity(0, 0)
		objects.slaves[1].body:setLinearVelocity(0, 0)
		objects.slaves[2].body:setLinearVelocity(0, 0)
		objects.mela.body:setPosition(math.random(638) + 6 + 20, math.random(638) + 6 + 20)
		gameover = false
	end
end
function add(a, b, coll)
	if (((a == "mela")and(b == "palla")) or ((b == "mela")and(a == "palla"))) then
		objects.mela.body:setPosition(math.random(638) + 6 + 20, math.random(638) + 6 + 20)
		
		nslaves = nslaves + 1
		
		objects.slaves[nslaves] = {}
		objects.slaves[nslaves].body = love.physics.newBody(world, objects.slaves[nslaves - 1].body:getX() + (objects.slaves[nslaves - 1].body:getX() - objects.slaves[nslaves - 2].body:getX()), objects.slaves[nslaves - 1].body:getY() + (objects.slaves[nslaves - 1].body:getY() - objects.slaves[nslaves - 2].body:getY()), 10, 0)
		objects.slaves[nslaves].shape = love.physics.newCircleShape(objects.slaves[nslaves].body, 0, 0, 13)
		objects.slaves[nslaves].shape:setData("slave")
		
		njoints = njoints + 1
		
		objects.joints[njoints] = {}
		objects.joints[njoints].joint = love.physics.newDistanceJoint( objects.slaves[nslaves - 1].body, objects.slaves[nslaves].body, objects.slaves[nslaves - 1].body:getX(), objects.slaves[nslaves - 1].body:getY(), objects.slaves[nslaves].body:getX(), objects.slaves[nslaves].body:getY())
		objects.joints[njoints].joint:setCollideConnected(false)
		objects.joints[njoints].joint:setDamping(.01)
	end
	if (((a == "slave")and(b == "palla")) or ((b == "slave")and(a == "palla"))) then
		gameover = true
	end
end

function persist(a, b, coll)
    
end

function rem(a, b, coll)
    
end

function result(a, b, coll)
    
end